OBJ
  rendez : "rendezvous"
  
CON
  pFileCommand = rendez#filecmd
  pFileParms   = rendez#fileparm

PRI RemoteFunctionCall(funcnum, pArgList) | locknum
  locknum := long[rendez#filelock]
  repeat until not lockset(locknum - 1)
  long[pFileParms] := pArgList
  long[pFileCommand] := (cogid << 16) | funcnum 
  repeat while long[pFileCommand]
  result := long[pFileParms]
  lockclr(locknum - 1)

PUB fgetc(stream)
  result := RemoteFunctionCall(1, @stream)

PUB fgets(str, num, stream)
  result := RemoteFunctionCall(2, @str)

PUB fopen(fname, mode)
  result := RemoteFunctionCall(3, @fname)

PUB fread(buffer, elem_size, num, stream)
  result := RemoteFunctionCall(4, @buffer)

PUB fwrite(buffer, elem_size, num, stream)
  result := RemoteFunctionCall(5, @buffer)

PUB fclose(stream) | file_data
  result := RemoteFunctionCall(6, @stream)

PUB remove(fname)
  result := RemoteFunctionCall(7, @fname)
    
PUB rename(fname1, fname2)
  result := RemoteFunctionCall(8, @fname1)

PUB create(fname)
  result := RemoteFunctionCall(9, @fname)

PUB getfilesize(stream)
  result := RemoteFunctionCall(10, @stream)

PUB mount_explicit(DO, CLK, DI, CS)
  result := RemoteFunctionCall(11, @DO)

PUB getcwd(str, num)
  result := RemoteFunctionCall(12, @str)

PUB chdir(path)
  result := RemoteFunctionCall(13, @path)

PUB format(size)
  result := RemoteFunctionCall(14, @size)

PUB opendir(path)
  result := RemoteFunctionCall(15, @path)

PUB readdir(stream)
  result := RemoteFunctionCall(16, @stream)

PUB closedir(stream)
  result := RemoteFunctionCall(17, @stream)

PUB ftell(stream)
  result := RemoteFunctionCall(18, @stream)

PUB fseek(stream, position, origin)
  result := RemoteFunctionCall(19, @stream)

PUB fflush(stream)
  result := RemoteFunctionCall(20, @stream)

PUB mkdir(fname)
  result := RemoteFunctionCall(21, @fname)

PUB chmod(fname, modebits)
  result := RemoteFunctionCall(22, @fname)

PUB getmod(fname)
  result := RemoteFunctionCall(23, @fname)

PUB run(argc, argv, cognum1)
  result := RemoteFunctionCall(24, @argc)

PUB kill(cognum)
  result := RemoteFunctionCall(25, @cognum)