CON
  _clkmode = xinput
  _xinfreq = $4E495053 ' SPIN

OBJ
  c : "clib_os"
  rendez : "rendezvous"

PUB main(argc, argv) | cognum, parmstr, entryptr, type
  if argc <> 2
    usage
  parmstr := long[argv][1]
  cognum := byte[parmstr] - "0"
  if cognum < 0 OR cognum > 7 OR byte[parmstr][1]
    usage
  entryptr := rendez#cogtable + (cognum * 24)
  type := byte[entryptr]
  ifnot type
    c.printf1(string("Process %d is not running\n"), cognum)
    c.exit(1)

  cogstop(cognum)
  if type == 1 ' SPIN
    c.free(word[entryptr+20])

  byte[entryptr] := 0

PUB usage
  c.printf0(string("usage: kill procnum\n"))
  c.exit(1)