CON
  _clkmode = xinput
  _xinfreq = $4E495053 ' SPIN

OBJ
  c : "clib_os"

DAT
  longlist long 0
  argi long 0
  total long 0
  numfiles long 0

PUB main(argc, argv)
  total := 0
  numfiles := 0
  argi := 1
  longlist := 0
  if argc => 2 AND byte[long[argv][1]] == "-"
    argi++
    if strcomp(long[argv][1], string("-l"))
      longlist := 1
    else
      usage
  if argi => argc
    listfiles(string("."))
    c.exit(1)
  repeat while argi < argc
    listfiles(long[argv][argi++])

PUB listfiles(path) | handle, filesize, attrib, astr[2], aptr, pdirent
  handle := c.opendir(path)
  ifnot handle
    c.printf1(string("Could not find %s\n"), path)
    return
  repeat while (pdirent := c.readdir(handle))
    filesize := long[pdirent][0]
    attrib := long[pdirent][1]
    total += filesize
    aptr := @astr
    c.strcpy(aptr, string("drwx"))
    ifnot attrib & $10
      byte[aptr] := "-"
    if attrib & 1
      byte[aptr][2] := "-"
    ifnot attrib & $20
      byte[aptr][3] := "-"
    if longlist
      c.printf3(STRING("%s %6d %s\n"), @astr, filesize, pdirent + 8)
    else
      c.printf1(string("%s\n"), pdirent + 8)
    numfiles++
  if longlist
    c.printf2(STRING("%6d files, %d bytes\n"), numfiles, total)
  c.closedir(handle)

PUB usage
  c.printf0(string("ls [-l] [file list]\n"))
  c.exit(2)
