CON
  _clkmode = xinput
  _xinfreq = $4E495053 ' SPIN

OBJ
  c : "clib_os"

PUB main(argc, argv) | argi, num, infile, outfile, buf[25], path, attrib, target, attrib1, fname
  c.printf2(string("getmod %s %b\n"), long[argv][1], c.getmod(long[argv][1]))
  c.exit(0)

  if argc < 3
    c.printf0(string("usage: cp file1 [file2 ...] path\n"))
    c.exit(@@0)
  path := long[argv][argc-1]
  'c.printf1(string("path = %s\n"), path)
  if strcomp(path, string("."))
    attrib := %1000
  else
    attrib := c.getmod(path)
    if attrib <> -1
      ifnot attrib & %0010
        c.printf1(string("%s is read only\n"), path)
        c.exit(@@0)
      attrib &= %1000
      if attrib == 0 AND argc > 3
        c.printf1(string("%s is not a directory\n"), path)
        c.exit(@@0)
    else
      attrib := 0

  target := @buf
  repeat argi from 1 to argc-2
    fname := long[argv][argi]
    infile := c.fopen(fname, string("r"))
    ifnot infile
      c.printf1(string("Could not open input file %s\n"), fname)
      c.exit(@@0)
    attrib1 := c.getmod(fname)
    if attrib1 & %1000
      c.printf1(string("%s is a directory\n"), fname)
      c.fclose(infile)
      c.exit(@@0)

    c.strcpy(target, path)
    if attrib
      c.strcat(target, string("/"))
      c.strcat(target, GetFileName(fname))
    'c.printf1(string("output file %s\n"), target)
    outfile := c.fopen(target, string("w"))
    ifnot outfile
      c.printf1(string("Could not open output file %s\n"), target)
      c.fclose(infile)
      c.exit(@@0)
    c.chmod(target, attrib1)
    repeat while (num := c.fread(@buf, 1, 100, infile)) > 0
      c.fwrite(@buf, 1, num, outfile)
    c.fclose(infile)
    c.fclose(outfile)

PRI GetFileName(path) | len
  len := strsize(path)
  if len =< 0
    return path
  path += len

  repeat while len--
    if byte[--path] == "/"
      return path + 1

  return path
